Panda3D

Public Types | Public Member Functions | List of all members
CopyOnWritePointerTo< T > Class Template Reference

A template wrapper around the above class, mainly to handle the little typecasting niceties. More...

`#include "copyOnWritePointer.h"`

Inheritance diagram for CopyOnWritePointerTo< T >:

## Public Types
typedef T | To

## Public Member Functions
| CopyOnWritePointerTo (const CopyOnWritePointerTo< T > &copy)
| CopyOnWritePointerTo (CopyOnWritePointerTo &&from) noexcept
| CopyOnWritePointerTo (PointerTo< T > &&from) noexcept
| CopyOnWritePointerTo (To *object=nullptr)
const To * | get_read_pointer (Thread *current_thread=Thread::get_current_thread()) const
| See CopyOnWritePointer::get_read_pointer(). More...
To * | get_unsafe_pointer ()
| See CopyOnWritePointer::get_unsafe_pointer(). More...
To * | get_write_pointer ()
| See CopyOnWritePointer::get_write_pointer(). More...
void | operator= (const CopyOnWritePointerTo< T > &copy)
void | operator= (CopyOnWritePointerTo &&from) noexcept
void | operator= (PointerTo< T > &&from) noexcept
void | operator= (To *object)
Public Member Functions inherited from CopyOnWritePointer
| CopyOnWritePointer (const CopyOnWritePointer &copy)
| CopyOnWritePointer (CopyOnWriteObject *object=nullptr)
| CopyOnWritePointer (CopyOnWritePointer &&from) noexcept
| CopyOnWritePointer (PointerTo< CopyOnWriteObject > &&from) noexcept
void | clear ()
| Sets the pointer to NULL. More...
const CopyOnWriteObject * | get_read_pointer (Thread *current_thread) const
| Returns a pointer locked for read. More...
CopyOnWriteObject * | get_unsafe_pointer ()
| Returns an unlocked pointer that you can write to. More...
CopyOnWriteObject * | get_write_pointer ()
| Returns a pointer locked for write. More...
bool | is_null () const
| Returns true if the CopyOnWritePointer contains a NULL pointer, false otherwise. More...
bool | operator!= (const CopyOnWritePointer &other) const
bool | operator< (const CopyOnWritePointer &other) const
void | operator= (const CopyOnWritePointer &copy)
void | operator= (CopyOnWriteObject *object)
void | operator= (CopyOnWritePointer &&from) noexcept
void | operator= (PointerTo< CopyOnWriteObject > &&from) noexcept
bool | operator== (const CopyOnWritePointer &other) const
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...

## Detailed Description

### template<class T>
class CopyOnWritePointerTo< T >

A template wrapper around the above class, mainly to handle the little typecasting niceties.

Definition at line 74 of file copyOnWritePointer.h.

## Member Function Documentation

## ◆ get_read_pointer()

template<class T >

const CopyOnWritePointerTo< T >::To * CopyOnWritePointerTo< T >::get_read_pointer | ( | Thread * | current_thread = `Thread::get_current_thread()` | ) | const
| inline

See CopyOnWritePointer::get_read_pointer().

Definition at line 375 of file copyOnWritePointer.I.

## ◆ get_unsafe_pointer()

template<class T >

CopyOnWritePointerTo< T >::To * CopyOnWritePointerTo< T >::get_unsafe_pointer
| inline

See CopyOnWritePointer::get_unsafe_pointer().

Definition at line 415 of file copyOnWritePointer.I.

## ◆ get_write_pointer()

template<class T >

CopyOnWritePointerTo< T >::To * CopyOnWritePointerTo< T >::get_write_pointer
| inline

See CopyOnWritePointer::get_write_pointer().

Definition at line 403 of file copyOnWritePointer.I.

The documentation for this class was generated from the following files:

- panda/src/putil/copyOnWritePointer.h
- panda/src/putil/copyOnWritePointer.I